*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\DragAccept\\DROPFILE.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Procedure MAIN()
*+               Function OnMouseHover()
*+               Function Drop_Detect()
*+               Function MyEvents()
*+
*+    Reformatted by Click! 2.05.30 on Mar-24-2020 at  6:45 am
*+
*+--------------------------------------------------------------------

#include "HMG.CH"

#define WM_DROPFILES    0x0233

STATIC cDropForm := ""
STATIC cDropCont := ""

MEMVAR hControl, _HMG_SYSDATA

*+--------------------------------------------------------------------
*+
*+    Procedure MAIN()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE MAIN

LOCAL nIndex
PUBLIC hControl, _HMG_SYSDATA

   DEFINE WINDOW DropDemo ;
              AT 0, 0 ;
              WIDTH 1024 ;
              HEIGHT 768 ;
              TITLE "Drop Demo" ;
              ICON "A1MAIN" ;
              ON INIT Nil ;
              NOSIZE ;
              NOMAXIMIZE ;
              NOMINIMIZE ;
              MAIN

      DEFINE EDITBOX Drop_Edit1
         ROW 20
         COL 20
         WIDTH 500
         HEIGHT 170
         VALUE ""
         FONTNAME "Arial"
         FONTSIZE 9
         TABSTOP .T.
         VISIBLE .T.
         READONLY .F.
         HSCROLLBAR .T.
         VSCROLLBAR .T.
      END EDITBOX

      DEFINE EDITBOX Drop_Edit2
         ROW 20
         COL 520
         WIDTH 500
         HEIGHT 170
         VALUE ""
         FONTNAME "Arial"
         FONTSIZE 9
         TABSTOP .T.
         VISIBLE .T.
         READONLY .F.
         HSCROLLBAR .T.
         VSCROLLBAR .T.
      END EDITBOX

      DEFINE TEXTBOX Drop_Edit3
         ROW 200
         COL 20
         WIDTH 500
         HEIGHT 170
         VALUE ""
         FONTNAME "Arial"
         FONTSIZE 9
         TABSTOP .T.
         VISIBLE .T.
         READONLY .F.
         HSCROLLBAR .T.
         VSCROLLBAR .T.
      END EDITBOX

      DEFINE EDITBOX Drop_Edit4
         ROW 200
         COL 520
         WIDTH 500
         HEIGHT 170
         VALUE ""
         FONTNAME "Arial"
         FONTSIZE 9
         TABSTOP .T.
         VISIBLE .T.
         READONLY .F.
         HSCROLLBAR .T.
         VSCROLLBAR .T.
      END EDITBOX

      DEFINE LABEL Label_1
         ROW 400
         COL 20
         WIDTH 1000
         HEIGHT 30
         VALUE "drop some files from explorer INTO Control"
         FONTNAME "Arial"
         FONTSIZE 20
         VISIBLE .T.
         ACTION Nil
         CENTERALIGN .T.
      END LABEL

   END WINDOW

   // NEED this line
   DragAcceptFiles( DropDemo.HANDLE, .t. )

   // disable 1st EDIT ... does not work
   hControl := GetControlHandle( "Drop_Edit1", "DropDemo" )
   DragAcceptFiles( hControl, .F. )

   CREATE EVENT PROCNAME OnMouseHover() HWND DropDemo.HANDLE

   // this work with Window.Handle
   CREATE EVENT PROCNAME Drop_Detect() HWND DropDemo.HANDLE STOREINDEX nIndex
   EventProcessAllHookMessage( nIndex, .T. )

   ON KEY ESCAPE OF DropDemo ACTION DropDemo.Release
   CENTER WINDOW DropDemo
   ACTIVATE WINDOW DropDemo

RETURN

*+--------------------------------------------------------------------
*+
*+    Function OnMouseHover()
*+
*+--------------------------------------------------------------------
*+
FUNCTION OnMouseHover()          // hWnd, cFormName )
LOCAL cControl := ""
LOCAL cForm    := ""
LOCAL nCol, nRow,hWnd
LOCAL nIndex
LOCAL cCtrlType

   GetCursorPos (@nCol, @nRow)
   hWnd := WindowFromPoint (nCol, nRow)
   nIndex := GetControlIndexByHandle (hWnd)
   IF nIndex > 0
      cCtrlType := IF( nIndex > 0, GetControlTypeByIndex (nIndex) , "")
      * msginfo(cCtrlType)
      IF cCtrlType = "EDIT"
         GetControlNameByHandle( hWnd, @cControl, @cForm )
         IF !EMPTY( cControl )
            cDropCont := cControl     // field-wide STATIC
            cDropForm := cForm        // field-wide STATIC
         ENDIF
      ELSE
         cDropCont := ""
         cDropForm := ""
      ENDIF
   ELSE
      cDropCont := ""
      cDropForm := ""
   ENDIF
RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Function Drop_Detect()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Drop_Detect()

LOCAL nHWnd   := EventHWND()
LOCAL nMsg    := EventMSG()
LOCAL nWParam := EventWPARAM()
LOCAL nLParam := EventLPARAM()
LOCAL aFiles, nLen, i
LOCAL cText    := ""
LOCAL cControl := ""
LOCAL cForm    := ""

   DO CASE
      CASE nMsg == WM_MOUSEHOVER .OR. nMsg == WM_NCMOUSEHOVER
         MSGINFO( "WM_MOUSEHOVER" )

      CASE nMsg == WM_DROPFILES
         //  MSGINFO( "WM_DROPFILES" )

         IF !EMPTY( cDropForm ) .AND. !EMPTY( cDropCont )
            SetProperty( cDropForm, cDropCont, "Value", "" )

            aFiles := DragQueryFileS( nWParam )
            nLen := LEN( aFiles )
            FOR i := 1 TO nLen
               cText += aFiles[ i ] + CRLF
            NEXT

            SetProperty( "DropDemo", cDropCont, "Value", cText )
         ENDIF

   ENDCASE

RETURN Nil

//
*+ EOF: DROPFILE.PRG
//
